package com.fp.persistence.pgeneral.safe;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TSAFEUSER*/
@Entity(name="TsafeUser")
@Table(name="TSAFEUSER")
public class TsafeUser extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TsafeUser
*/
@Id
@Column(name="USERCODE" ,nullable=false, updatable=false)
private String pk;
@Column(name="PERSONCODE", nullable=true)

/**
* Codigo de persona
*/
private Integer personcode;

@Column(name="INTERNALCODE", nullable=true)

/**
* Codigo de usuario interno, se utiliza para crear secuencias por usuario.
*/
private Integer internalcode;

@Column(name="COMPANYCODE", nullable=true)

/**
* Codigo de compania
*/
private Integer companycode;

/**Contructor por defecto*/
public TsafeUser(){
}
/**Contructor de TsafeUser
@param pPk Clave Primaria del entity
*/
public TsafeUser(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TsafeUser
*/
public static TsafeUser find(EntityManager pEntityManager,Object pKey) throws Exception{
    TsafeUser obj = pEntityManager.find(TsafeUser.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TsafeUser
@return El objeto que referencia a la Clave primaria de TsafeUser
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TsafeUser
@param pPk El objeto que referencia a la nueva Clave primaria de TsafeUser
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de internalcode
@return valor de internalcode*/
public Integer getInternalcode(){
  return internalcode;
}
/**Fija el valor de internalcode
@param pInternalcode nuevo Valor de internalcode*/
public void setInternalcode(Integer pInternalcode){
  internalcode=pInternalcode;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TsafeUser))return false;
    TsafeUser that = (TsafeUser) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TsafeUser
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TsafeUser
*/
public Object createInstance(){
 TsafeUser instance=new TsafeUser();	
 return instance;
}
/**Clona la entidad TsafeUser
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TsafeUser p=(TsafeUser)this.clone();
  return p;
}
}
